# Valheim Ward Event Blocker

A lightweight Valheim mod to make Wards protect a player from random events. 
This mod works on servers (dedicated or otherwise), and singleplayer games. 
It is safe to have it installed when you join other servers as a client, it just won't do anything.

## Features

This mod gives an additional purpose to wards in-game by allowing them to hide players from "raids" (random events, e.g. *The forest is moving*).

In the vanilla version of Valheim, random events can occur when the [following three conditions are met](https://valheim.fandom.com/wiki/Events):

1. The player is in the required biome
2. The player is not in a dungeon
3. The player is within 40 meters of at least 3 base structures

Basically, with this mod installed, there is another condition:

4. The player is not inside any **enabled** ward

This means that the player can essentially opt-in/opt-out of potential raids by toggling the state of the ward.

## Installation

**BepinEx for Valheim is required for this plugin to work**

Install from your favorite mod manager, or manually by following these instructions:

1. Download and extract the build artifact for the [latest release](https://gitlab.com/ben-bartholomew/valheim-ward-event-blocker/-/releases)
2. Place the `bbar.Mods.WardEventBlocker.dll` file into `<GameDirectory>\Bepinex\plugins`
3. The first time the game starts with the plugin loaded, it will generate a config file: `<GameDirectory>\BepinEx\config\bbar.Mods.WardEventBlocker.cfg`
3. Open the cfg file to change configuration as needed. Any manual changes to that file will require a restart. The plugin is also compatible with the BepinEx configuration manager.

## Configuration

- ProtectionRadius
  - Default: 32
  - The radius for wards to hide a player from a random event. This defaults to the vanilla Valheim ward radius. Changing this has no effect on the range of the vanilla ward functionality.
- FlashWardsOnEventBlocked
  - Default: false
  - Whether or not wards should flash when they hide a player from the random event system.

## Quick Links

- [Thunderstore Listing](https://valheim.thunderstore.io/package/bbar/WardEventBlocker/)
- [Bugs and Improvements](https://gitlab.com/ben-bartholomew/valheim-ward-event-blocker/-/issues)

## Attributions

- [Shield](https://thenounproject.com/icon/shield-1014798/) icon by [Jemis mali](https://thenounproject.com/jemismali/) on [The Noun Project](https://thenounproject.com/) (CC BY 3.0)

